using System;
using System.Collections;
using System.Xml.Serialization;

using MessageRouting;

namespace Overlook {
	[Serializable,
	XmlRootAttribute("DirEntry",Namespace=SerializationConfig.OVERLOOK_NAMESPACE,IsNullable=true)]
	public class DirEntry {

		private string name;
		private DirEntryType entryType;

		public DirEntry() {
		}

		public DirEntry(string name, DirEntryType entryType) {
			this.name = name;
			this.entryType = entryType;
		}

		[XmlElementAttribute("DirEntryName",
			 Namespace=Overlook.SerializationConfig.OVERLOOK_NAMESPACE)]
		public string EntryName {
			get {return name;}
			set {name = value;}
		}

		[XmlElementAttribute("DirEntryType",
			 Namespace=Overlook.SerializationConfig.OVERLOOK_NAMESPACE)]
		public DirEntryType EntryType {
			get {return entryType;}
			set {entryType = value;}
		}
	}

	[Serializable,
	XmlRootAttribute("DirEntryArray",Namespace=Overlook.SerializationConfig.OVERLOOK_NAMESPACE,IsNullable=true)]
	public class DirEntryArray {

		public DirEntryArray() {
		}

		public DirEntryArray(DirEntry[] entries) {
			this.entries = entries;
		}

		private DirEntry[] entries;

		[XmlArray( ElementName="DirEntryArrayEntries",
			 Namespace=Overlook.SerializationConfig.OVERLOOK_NAMESPACE, IsNullable=true)]
		[XmlArrayItem( ElementName="DirEntryArrayElem", Type=typeof(DirEntry),
			 IsNullable=true, Namespace=Overlook.SerializationConfig.OVERLOOK_NAMESPACE)]
		public DirEntry[] Entries {
			get {return this.entries;}
			set {this.entries = value;}
		}
	}

	public enum DirEntryType {nameValuePair, dirEntry};
}
